---
title: Path2D.addPath()
slug: Web/API/Path2D/addPath
tags:
  - API
  - Canvas
  - Method
  - Path2D
  - Path2D.addPath
  - Reference
---
<div>{{APIRef("Canvas API")}}</div>

<p>The <code><strong>Path2D</strong></code><strong><code>.addPath()</code></strong> method of the Canvas 2D API adds one {{domxref("Path2D")}} object to another <code>Path2D</code> object.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <em>path</em>.addPath(<em>path</em> [, <em>transform</em>]);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>path</code></dt>
 <dd>A {{domxref("Path2D")}} path to add.</dd>
 <dt><code>transform</code> {{optional_inline}}</dt>
 <dd>A {{domxref("DOMMatrix")}} to be used as the transformation matrix for the path that is added. (Technically a <code>DOMMatrixInit</code> object).</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Adding_a_path_to_an_existing_path">Adding a path to an existing path</h3>

<p>This example adds one path to another.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas"&gt;&lt;/canvas&gt;</pre>

<h4 id="JavaScript">JavaScript</h4>

<p>First, we create two separate {{domxref("Path2D")}} objects, each of which contains a rectangle made using the {{domxref("CanvasRenderingContext2D.rect()", "rect()")}} method. We then create a matrix using {{Domxref("document.createElementNS()")}} and <code>createSVGMatrix()</code>. We then add the second path to the first using <code>addPath()</code>, also applying the matrix to move the second path to the right. Finally, we draw the first path (which now contains both rectangles) using {{domxref("CanvasRenderingContext2D.fill()", "fill()")}}.</p>

<pre class="brush: js; highlight:[19]">const canvas = document.getElementById('canvas');
const ctx = canvas.getContext('2d');

// Create first path and add a rectangle
let p1 = new Path2D();
p1.rect(0, 0, 100, 150);

// Create second path and add a rectangle
let p2 = new Path2D();
p2.rect(0, 0, 100, 75);

// Create transformation matrix that moves 200 points to the right
let m = document.createElementNS('http://www.w3.org/2000/svg', 'svg').createSVGMatrix();
m.a = 1; m.b = 0;
m.c = 0; m.d = 1;
m.e = 200; m.f = 0;

// Add second path to the first path
p1.addPath(p2, m);

// Draw the first path
ctx.fill(p1);
</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Adding_a_path_to_an_existing_path', 700, 180) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-path2d-addpath", "Path2D.addPath()")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial defintion.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Path2D.addPath")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("Path2D")}}</li>
</ul>
